// IControl.h: interface for the IControl class.
//
//////////////////////////////////////////////////////////////////////

#include <string>
#if !defined(AFX_ICONTROL_H__6C6951AC_F955_4AE1_81CD_2E79A52068EE__INCLUDED_)
#define AFX_ICONTROL_H__6C6951AC_F955_4AE1_81CD_2E79A52068EE__INCLUDED_


#include "SlPara.h"
#include "SerialComm.h"

using namespace std;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class IControl  
{
public:



	IControl();
	virtual ~IControl();

	//motor-specific methods	
	virtual void StartMotor(char Motor, string Position){};
	virtual void StopMotor(char Motor){};
	virtual void SetParameters(char motor, bool vel){};
	virtual void SetMotorToZero(char Motor){};
	virtual void ReadMotorStatus(string Motor){};
	virtual void MotorPower(bool status){};
	virtual void CalibrateMotor(char motor, string position){};

	//non-motor-specific methods
	virtual void InitComms(){};
	virtual void CloseComms(){};
	virtual BOOL IsConnectionReady() {return false;};
	virtual void InitController(){};
	virtual void SetControllerOutOn(int nOutput){};
	virtual void SetControllerOutOff(int nOutput){};
	virtual void ReadControllerStatus(string sPort){};
	virtual void SendToController(string Line,string sender){};
	virtual void ReadResponse(){};
	virtual void CheckTimeout(){};
};

#endif // !defined(AFX_ICONTROL_H__6C6951AC_F955_4AE1_81CD_2E79A52068EE__INCLUDED_)
